<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>21.23. http.cookies — HTTP state management &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="21. Internet Protocols and Support" href="internet.html" />
    <link rel="next" title="21.24. http.cookiejar — Cookie handling for HTTP clients" href="http.cookiejar.html" />
    <link rel="prev" title="21.22. http.server — HTTP servers" href="http.server.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="http.cookiejar.html" title="21.24. http.cookiejar — Cookie handling for HTTP clients"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="http.server.html" title="21.22. http.server — HTTP servers"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" accesskey="U">21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-http.cookies">
<span id="http-cookies-http-state-management"></span><h1>21.23. <a class="reference internal" href="#module-http.cookies" title="http.cookies: Support for HTTP state management (cookies)."><code class="xref py py-mod docutils literal"><span class="pre">http.cookies</span></code></a> &#8212; HTTP state management<a class="headerlink" href="#module-http.cookies" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/http/cookies.py">Lib/http/cookies.py</a></p>
<hr class="docutils" />
<p>The <a class="reference internal" href="#module-http.cookies" title="http.cookies: Support for HTTP state management (cookies)."><code class="xref py py-mod docutils literal"><span class="pre">http.cookies</span></code></a> module defines classes for abstracting the concept of
cookies, an HTTP state management mechanism. It supports both simple string-only
cookies, and provides an abstraction for having any serializable data-type as
cookie value.</p>
<p>The module formerly strictly applied the parsing rules described in the
<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> and <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2068.html"><strong>RFC 2068</strong></a> specifications.  It has since been discovered that
MSIE 3.0x doesn&#8217;t follow the character rules outlined in those specs and also
many current day browsers and servers have relaxed parsing rules when comes to
Cookie handling.  As a result, the parsing rules used are a bit less strict.</p>
<p>The character set, <a class="reference internal" href="string.html#string.ascii_letters" title="string.ascii_letters"><code class="xref py py-data docutils literal"><span class="pre">string.ascii_letters</span></code></a>, <a class="reference internal" href="string.html#string.digits" title="string.digits"><code class="xref py py-data docutils literal"><span class="pre">string.digits</span></code></a> and
<code class="docutils literal"><span class="pre">!#$%&amp;'*+-.^_`|~:</span></code> denote the set of valid characters allowed by this module
in Cookie name (as <a class="reference internal" href="#http.cookies.Morsel.key" title="http.cookies.Morsel.key"><code class="xref py py-attr docutils literal"><span class="pre">key</span></code></a>).</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>Allowed &#8216;:&#8217; as a valid Cookie name character.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">On encountering an invalid cookie, <a class="reference internal" href="#http.cookies.CookieError" title="http.cookies.CookieError"><code class="xref py py-exc docutils literal"><span class="pre">CookieError</span></code></a> is raised, so if your
cookie data comes from a browser you should always prepare for invalid data
and catch <a class="reference internal" href="#http.cookies.CookieError" title="http.cookies.CookieError"><code class="xref py py-exc docutils literal"><span class="pre">CookieError</span></code></a> on parsing.</p>
</div>
<dl class="exception">
<dt id="http.cookies.CookieError">
<em class="property">exception </em><code class="descclassname">http.cookies.</code><code class="descname">CookieError</code><a class="headerlink" href="#http.cookies.CookieError" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception failing because of <span class="target" id="index-2"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> invalidity: incorrect attributes,
incorrect <em class="mailheader">Set-Cookie</em> header, etc.</p>
</dd></dl>

<dl class="class">
<dt id="http.cookies.BaseCookie">
<em class="property">class </em><code class="descclassname">http.cookies.</code><code class="descname">BaseCookie</code><span class="sig-paren">(</span><span class="optional">[</span><em>input</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie" title="Permalink to this definition">¶</a></dt>
<dd><p>This class is a dictionary-like object whose keys are strings and whose values
are <a class="reference internal" href="#http.cookies.Morsel" title="http.cookies.Morsel"><code class="xref py py-class docutils literal"><span class="pre">Morsel</span></code></a> instances. Note that upon setting a key to a value, the
value is first converted to a <a class="reference internal" href="#http.cookies.Morsel" title="http.cookies.Morsel"><code class="xref py py-class docutils literal"><span class="pre">Morsel</span></code></a> containing the key and the value.</p>
<p>If <em>input</em> is given, it is passed to the <a class="reference internal" href="#http.cookies.BaseCookie.load" title="http.cookies.BaseCookie.load"><code class="xref py py-meth docutils literal"><span class="pre">load()</span></code></a> method.</p>
</dd></dl>

<dl class="class">
<dt id="http.cookies.SimpleCookie">
<em class="property">class </em><code class="descclassname">http.cookies.</code><code class="descname">SimpleCookie</code><span class="sig-paren">(</span><span class="optional">[</span><em>input</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.SimpleCookie" title="Permalink to this definition">¶</a></dt>
<dd><p>This class derives from <a class="reference internal" href="#http.cookies.BaseCookie" title="http.cookies.BaseCookie"><code class="xref py py-class docutils literal"><span class="pre">BaseCookie</span></code></a> and overrides <code class="xref py py-meth docutils literal"><span class="pre">value_decode()</span></code>
and <code class="xref py py-meth docutils literal"><span class="pre">value_encode()</span></code> to be the identity and <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-func docutils literal"><span class="pre">str()</span></code></a> respectively.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="http.cookiejar.html#module-http.cookiejar" title="http.cookiejar: Classes for automatic handling of HTTP cookies."><code class="xref py py-mod docutils literal"><span class="pre">http.cookiejar</span></code></a></dt>
<dd>HTTP cookie handling for web <em>clients</em>.  The <a class="reference internal" href="http.cookiejar.html#module-http.cookiejar" title="http.cookiejar: Classes for automatic handling of HTTP cookies."><code class="xref py py-mod docutils literal"><span class="pre">http.cookiejar</span></code></a> and
<a class="reference internal" href="#module-http.cookies" title="http.cookies: Support for HTTP state management (cookies)."><code class="xref py py-mod docutils literal"><span class="pre">http.cookies</span></code></a> modules do not depend on each other.</dd>
<dt><span class="target" id="index-3"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> - HTTP State Management Mechanism</dt>
<dd>This is the state management specification implemented by this module.</dd>
</dl>
</div>
<div class="section" id="cookie-objects">
<span id="id1"></span><h2>21.23.1. Cookie Objects<a class="headerlink" href="#cookie-objects" title="Permalink to this headline">¶</a></h2>
<dl class="method">
<dt id="http.cookies.BaseCookie.value_decode">
<code class="descclassname">BaseCookie.</code><code class="descname">value_decode</code><span class="sig-paren">(</span><em>val</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie.value_decode" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a decoded value from a string representation. Return value can be any
type. This method does nothing in <a class="reference internal" href="#http.cookies.BaseCookie" title="http.cookies.BaseCookie"><code class="xref py py-class docutils literal"><span class="pre">BaseCookie</span></code></a> &#8212; it exists so it can be
overridden.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.BaseCookie.value_encode">
<code class="descclassname">BaseCookie.</code><code class="descname">value_encode</code><span class="sig-paren">(</span><em>val</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie.value_encode" title="Permalink to this definition">¶</a></dt>
<dd><p>Return an encoded value. <em>val</em> can be any type, but return value must be a
string. This method does nothing in <a class="reference internal" href="#http.cookies.BaseCookie" title="http.cookies.BaseCookie"><code class="xref py py-class docutils literal"><span class="pre">BaseCookie</span></code></a> &#8212; it exists so it can
be overridden.</p>
<p>In general, it should be the case that <a class="reference internal" href="#http.cookies.BaseCookie.value_encode" title="http.cookies.BaseCookie.value_encode"><code class="xref py py-meth docutils literal"><span class="pre">value_encode()</span></code></a> and
<a class="reference internal" href="#http.cookies.BaseCookie.value_decode" title="http.cookies.BaseCookie.value_decode"><code class="xref py py-meth docutils literal"><span class="pre">value_decode()</span></code></a> are inverses on the range of <em>value_decode</em>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.BaseCookie.output">
<code class="descclassname">BaseCookie.</code><code class="descname">output</code><span class="sig-paren">(</span><em>attrs=None</em>, <em>header='Set-Cookie:'</em>, <em>sep='\r\n'</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie.output" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a string representation suitable to be sent as HTTP headers. <em>attrs</em> and
<em>header</em> are sent to each <a class="reference internal" href="#http.cookies.Morsel" title="http.cookies.Morsel"><code class="xref py py-class docutils literal"><span class="pre">Morsel</span></code></a>&#8216;s <a class="reference internal" href="#http.cookies.BaseCookie.output" title="http.cookies.BaseCookie.output"><code class="xref py py-meth docutils literal"><span class="pre">output()</span></code></a> method. <em>sep</em> is used
to join the headers together, and is by default the combination <code class="docutils literal"><span class="pre">'\r\n'</span></code>
(CRLF).</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.BaseCookie.js_output">
<code class="descclassname">BaseCookie.</code><code class="descname">js_output</code><span class="sig-paren">(</span><em>attrs=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie.js_output" title="Permalink to this definition">¶</a></dt>
<dd><p>Return an embeddable JavaScript snippet, which, if run on a browser which
supports JavaScript, will act the same as if the HTTP headers was sent.</p>
<p>The meaning for <em>attrs</em> is the same as in <a class="reference internal" href="#http.cookies.BaseCookie.output" title="http.cookies.BaseCookie.output"><code class="xref py py-meth docutils literal"><span class="pre">output()</span></code></a>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.BaseCookie.load">
<code class="descclassname">BaseCookie.</code><code class="descname">load</code><span class="sig-paren">(</span><em>rawdata</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.BaseCookie.load" title="Permalink to this definition">¶</a></dt>
<dd><p>If <em>rawdata</em> is a string, parse it as an <code class="docutils literal"><span class="pre">HTTP_COOKIE</span></code> and add the values
found there as <a class="reference internal" href="#http.cookies.Morsel" title="http.cookies.Morsel"><code class="xref py py-class docutils literal"><span class="pre">Morsel</span></code></a>s. If it is a dictionary, it is equivalent to:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="k">for</span> <span class="n">k</span><span class="p">,</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">rawdata</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
    <span class="n">cookie</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="n">v</span>
</pre></div>
</div>
</dd></dl>

</div>
<div class="section" id="morsel-objects">
<span id="id2"></span><h2>21.23.2. Morsel Objects<a class="headerlink" href="#morsel-objects" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="http.cookies.Morsel">
<em class="property">class </em><code class="descclassname">http.cookies.</code><code class="descname">Morsel</code><a class="headerlink" href="#http.cookies.Morsel" title="Permalink to this definition">¶</a></dt>
<dd><p>Abstract a key/value pair, which has some <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> attributes.</p>
<p>Morsels are dictionary-like objects, whose set of keys is constant &#8212; the valid
<span class="target" id="index-5"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> attributes, which are</p>
<ul class="simple">
<li><code class="docutils literal"><span class="pre">expires</span></code></li>
<li><code class="docutils literal"><span class="pre">path</span></code></li>
<li><code class="docutils literal"><span class="pre">comment</span></code></li>
<li><code class="docutils literal"><span class="pre">domain</span></code></li>
<li><code class="docutils literal"><span class="pre">max-age</span></code></li>
<li><code class="docutils literal"><span class="pre">secure</span></code></li>
<li><code class="docutils literal"><span class="pre">version</span></code></li>
<li><code class="docutils literal"><span class="pre">httponly</span></code></li>
</ul>
<p>The attribute <code class="xref py py-attr docutils literal"><span class="pre">httponly</span></code> specifies that the cookie is only transferred
in HTTP requests, and is not accessible through JavaScript. This is intended
to mitigate some forms of cross-site scripting.</p>
<p>The keys are case-insensitive.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span><code class="xref py py-meth docutils literal"><span class="pre">__eq__()</span></code> now takes <a class="reference internal" href="#http.cookies.Morsel.key" title="http.cookies.Morsel.key"><code class="xref py py-attr docutils literal"><span class="pre">key</span></code></a> and <a class="reference internal" href="#http.cookies.Morsel.value" title="http.cookies.Morsel.value"><code class="xref py py-attr docutils literal"><span class="pre">value</span></code></a>
into account.</p>
</div>
</dd></dl>

<dl class="attribute">
<dt id="http.cookies.Morsel.value">
<code class="descclassname">Morsel.</code><code class="descname">value</code><a class="headerlink" href="#http.cookies.Morsel.value" title="Permalink to this definition">¶</a></dt>
<dd><p>The value of the cookie.</p>
<div class="deprecated">
<p><span class="versionmodified">Deprecated since version 3.5: </span>assigning to <code class="docutils literal"><span class="pre">value</span></code>; use <a class="reference internal" href="#http.cookies.Morsel.set" title="http.cookies.Morsel.set"><code class="xref py py-meth docutils literal"><span class="pre">set()</span></code></a> instead.</p>
</div>
</dd></dl>

<dl class="attribute">
<dt id="http.cookies.Morsel.coded_value">
<code class="descclassname">Morsel.</code><code class="descname">coded_value</code><a class="headerlink" href="#http.cookies.Morsel.coded_value" title="Permalink to this definition">¶</a></dt>
<dd><p>The encoded value of the cookie &#8212; this is what should be sent.</p>
<div class="deprecated">
<p><span class="versionmodified">Deprecated since version 3.5: </span>assigning to <code class="docutils literal"><span class="pre">coded_value</span></code>; use <a class="reference internal" href="#http.cookies.Morsel.set" title="http.cookies.Morsel.set"><code class="xref py py-meth docutils literal"><span class="pre">set()</span></code></a> instead.</p>
</div>
</dd></dl>

<dl class="attribute">
<dt id="http.cookies.Morsel.key">
<code class="descclassname">Morsel.</code><code class="descname">key</code><a class="headerlink" href="#http.cookies.Morsel.key" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the cookie.</p>
<div class="deprecated">
<p><span class="versionmodified">Deprecated since version 3.5: </span>assigning to <code class="docutils literal"><span class="pre">key</span></code>; use <a class="reference internal" href="#http.cookies.Morsel.set" title="http.cookies.Morsel.set"><code class="xref py py-meth docutils literal"><span class="pre">set()</span></code></a> instead.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.set">
<code class="descclassname">Morsel.</code><code class="descname">set</code><span class="sig-paren">(</span><em>key</em>, <em>value</em>, <em>coded_value</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.set" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the <em>key</em>, <em>value</em> and <em>coded_value</em> attributes.</p>
<div class="deprecated">
<p><span class="versionmodified">Deprecated since version 3.5: </span>The undocumented <em>LegalChars</em> parameter is ignored and will be removed in
a future version.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.isReservedKey">
<code class="descclassname">Morsel.</code><code class="descname">isReservedKey</code><span class="sig-paren">(</span><em>K</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.isReservedKey" title="Permalink to this definition">¶</a></dt>
<dd><p>Whether <em>K</em> is a member of the set of keys of a <a class="reference internal" href="#http.cookies.Morsel" title="http.cookies.Morsel"><code class="xref py py-class docutils literal"><span class="pre">Morsel</span></code></a>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.output">
<code class="descclassname">Morsel.</code><code class="descname">output</code><span class="sig-paren">(</span><em>attrs=None</em>, <em>header='Set-Cookie:'</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.output" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a string representation of the Morsel, suitable to be sent as an HTTP
header. By default, all the attributes are included, unless <em>attrs</em> is given, in
which case it should be a list of attributes to use. <em>header</em> is by default
<code class="docutils literal"><span class="pre">&quot;Set-Cookie:&quot;</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.js_output">
<code class="descclassname">Morsel.</code><code class="descname">js_output</code><span class="sig-paren">(</span><em>attrs=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.js_output" title="Permalink to this definition">¶</a></dt>
<dd><p>Return an embeddable JavaScript snippet, which, if run on a browser which
supports JavaScript, will act the same as if the HTTP header was sent.</p>
<p>The meaning for <em>attrs</em> is the same as in <a class="reference internal" href="#http.cookies.Morsel.output" title="http.cookies.Morsel.output"><code class="xref py py-meth docutils literal"><span class="pre">output()</span></code></a>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.OutputString">
<code class="descclassname">Morsel.</code><code class="descname">OutputString</code><span class="sig-paren">(</span><em>attrs=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.OutputString" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a string representing the Morsel, without any surrounding HTTP or
JavaScript.</p>
<p>The meaning for <em>attrs</em> is the same as in <a class="reference internal" href="#http.cookies.Morsel.output" title="http.cookies.Morsel.output"><code class="xref py py-meth docutils literal"><span class="pre">output()</span></code></a>.</p>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.update">
<code class="descclassname">Morsel.</code><code class="descname">update</code><span class="sig-paren">(</span><em>values</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.update" title="Permalink to this definition">¶</a></dt>
<dd><p>Update the values in the Morsel dictionary with the values in the dictionary
<em>values</em>.  Raise an error if any of the keys in the <em>values</em> dict is not a
valid <span class="target" id="index-6"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> attribute.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>an error is raised for invalid keys.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.copy">
<code class="descclassname">Morsel.</code><code class="descname">copy</code><span class="sig-paren">(</span><em>value</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.copy" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a shallow copy of the Morsel object.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>return a Morsel object instead of a dict.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.cookies.Morsel.setdefault">
<code class="descclassname">Morsel.</code><code class="descname">setdefault</code><span class="sig-paren">(</span><em>key</em>, <em>value=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.cookies.Morsel.setdefault" title="Permalink to this definition">¶</a></dt>
<dd><p>Raise an error if key is not a valid <span class="target" id="index-7"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2109.html"><strong>RFC 2109</strong></a> attribute, otherwise
behave the same as <a class="reference internal" href="stdtypes.html#dict.setdefault" title="dict.setdefault"><code class="xref py py-meth docutils literal"><span class="pre">dict.setdefault()</span></code></a>.</p>
</dd></dl>

</div>
<div class="section" id="example">
<span id="cookie-example"></span><h2>21.23.3. Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>The following example demonstrates how to use the <a class="reference internal" href="#module-http.cookies" title="http.cookies: Support for HTTP state management (cookies)."><code class="xref py py-mod docutils literal"><span class="pre">http.cookies</span></code></a> module.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">http</span> <span class="k">import</span> <span class="n">cookies</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;fig&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;newton&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;sugar&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;wafer&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="p">)</span> <span class="c"># generate HTTP headers</span>
<span class="go">Set-Cookie: fig=newton</span>
<span class="go">Set-Cookie: sugar=wafer</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="o">.</span><span class="n">output</span><span class="p">())</span> <span class="c"># same thing</span>
<span class="go">Set-Cookie: fig=newton</span>
<span class="go">Set-Cookie: sugar=wafer</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;rocky&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;road&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;rocky&quot;</span><span class="p">][</span><span class="s">&quot;path&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;/cookie&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="o">.</span><span class="n">output</span><span class="p">(</span><span class="n">header</span><span class="o">=</span><span class="s">&quot;Cookie:&quot;</span><span class="p">))</span>
<span class="go">Cookie: rocky=road; Path=/cookie</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="o">.</span><span class="n">output</span><span class="p">(</span><span class="n">attrs</span><span class="o">=</span><span class="p">[],</span> <span class="n">header</span><span class="o">=</span><span class="s">&quot;Cookie:&quot;</span><span class="p">))</span>
<span class="go">Cookie: rocky=road</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s">&quot;chips=ahoy; vienna=finger&quot;</span><span class="p">)</span> <span class="c"># load from a string (HTTP header)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="p">)</span>
<span class="go">Set-Cookie: chips=ahoy</span>
<span class="go">Set-Cookie: vienna=finger</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s">&#39;keebler=&quot;E=everybody; L=</span><span class="se">\\</span><span class="s">&quot;Loves</span><span class="se">\\</span><span class="s">&quot;; fudge=</span><span class="se">\\</span><span class="s">012;&quot;;&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="p">)</span>
<span class="go">Set-Cookie: keebler=&quot;E=everybody; L=\&quot;Loves\&quot;; fudge=\012;&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;oreo&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;doublestuff&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;oreo&quot;</span><span class="p">][</span><span class="s">&quot;path&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;/&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="p">)</span>
<span class="go">Set-Cookie: oreo=doublestuff; Path=/</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;twix&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;none for you&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;twix&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">value</span>
<span class="go">&#39;none for you&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span> <span class="o">=</span> <span class="n">cookies</span><span class="o">.</span><span class="n">SimpleCookie</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;number&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">7</span> <span class="c"># equivalent to C[&quot;number&quot;] = str(7)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;string&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;seven&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;number&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">value</span>
<span class="go">&#39;7&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">C</span><span class="p">[</span><span class="s">&quot;string&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">value</span>
<span class="go">&#39;seven&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">C</span><span class="p">)</span>
<span class="go">Set-Cookie: number=7</span>
<span class="go">Set-Cookie: string=seven</span>
</pre></div>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">21.23. <code class="docutils literal"><span class="pre">http.cookies</span></code> &#8212; HTTP state management</a><ul>
<li><a class="reference internal" href="#cookie-objects">21.23.1. Cookie Objects</a></li>
<li><a class="reference internal" href="#morsel-objects">21.23.2. Morsel Objects</a></li>
<li><a class="reference internal" href="#example">21.23.3. Example</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="http.server.html"
                        title="previous chapter">21.22. <code class="docutils literal"><span class="pre">http.server</span></code> &#8212; HTTP servers</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="http.cookiejar.html"
                        title="next chapter">21.24. <code class="docutils literal"><span class="pre">http.cookiejar</span></code> &#8212; Cookie handling for HTTP clients</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/http.cookies.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="http.cookiejar.html" title="21.24. http.cookiejar — Cookie handling for HTTP clients"
             >next</a> |</li>
        <li class="right" >
          <a href="http.server.html" title="21.22. http.server — HTTP servers"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" >21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>